#include "testlib.h"

#include <vector>
#include <map>
#include <set>
#include <functional>
#include <fstream>

using namespace std;

vector<map<int,int>> g;

map<pair<int,int>,int> e;

vector<bool> used;

int cnt = 0;

void dfs(int u) {
    used[u] = true;
    ++cnt;
    for (auto [v, c] : g[u]) {
        if (!used[v] &&  c - e[{u,v}] > 00) {
            dfs(v);
        }
    }
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    g.resize(n);
    used.resize(n);
    int m = inf.readInt();
    for (int i=0; i < m; ++i) {
        int u = inf.readInt() - 1;
        int v = inf.readInt() - 1;
        g[u][v]++;
        g[v][u]++;
    }

    dfs(0);
    if (cnt != n) {
        quitf(_fail, "doesn't connected");
    }
    cnt = 0;
    used = vector<bool>(n);

    int best = ans.readInt();

    int res = ouf.readInt();

    if (res < 0 || res > best) {
       quitf(_wa,"wrong res %d", res);
    }

    for (int i = 0; i < res; ++i) {
        int u = ouf.readInt() - 1;
        int v = ouf.readInt() - 1;
        if (u < 0 || u >= n) {
            quitf(_wa, "wrong edge");
        }
        if (v < 0 || v >= n) {
            quitf(_wa, "wrong edge");
        }
        if (g[u].count(v) == 0) {
            quitf(_wa, "wrong edge");
        }
        if (u > v) {
            quitf(_wa, "wrong edge");
        }
        e[{u,v}]++;
        e[{v,u}]++;
    } 

    dfs(0);

    if (cnt >= n) {
        quitf(_wa, "graph is connected");
    }
    if (res < best) {
        quit(_fail, "");
    }
    quitf(_ok, "");
}
